Package: CSAR
Type: Package
Title: Statistical tools for the analysis of ChIP-seq data
Version: 1.64.0
Date: 2025-07-24
Author: Jose M Muino
Description: Statistical tools for ChIP-seq data analysis. The package
        includes the statistical method described in Kaufmann et al.
        (2009) PLoS Biology: 7(4):e1000090. Briefly, Taking the average
        DNA fragment size subjected to sequencing into account, the
        software calculates genomic single-nucleotide read-enrichment
        values. After normalization, sample and control are compared
        using a test based on the Poisson distribution. Test statistic
        thresholds to control the false discovery rate are obtained
        through random permutation.
Depends: R (>= 2.15.0), S4Vectors, IRanges, Seqinfo, GenomicRanges
Maintainer: Jose M Muino <jose.muino@live.com>
Suggests: ShortRead, Biostrings
Imports: stats, utils
License: Artistic-2.0
LazyLoad: yes
LazyData: yes
biocViews: ChIPSeq, Transcription, Genetics
git_url: https://git.bioconductor.org/packages/CSAR
git_branch: RELEASE_3_23
git_last_commit: ee5e58c
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:28:45 UTC; biocbuild

### R code from vignette source 'CSAR.Rnw'

###################################################
### code chunk number 1: setup
###################################################
options(width=60)
options(continue=" ")
options(prompt="R> ")


###################################################
### code chunk number 2: loadData
###################################################
library(CSAR)
data("CSAR-dataset");
head(sampleSEP3_test)
head(controlSEP3_test)
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC$filenames
nhitsS$filenames


###################################################
### code chunk number 3: runScore
###################################################
test<-ChIPseqScore(control=nhitsC,sample=nhitsS,file="test",times=10000)
test$filenames
win<-sigWin(test)
head(win)
score2wig(test,file="test.wig",times=10000)
d<-distance2Genes(win=win,gff=TAIR8_genes_test)
d
genes<-genesWithPeaks(d)
head(genes)


###################################################
### code chunk number 4: runPermutation
###################################################
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
nulldist<-getPermutatedWinScores(file="test",nn=1:2)
getThreshold(winscores=values(win)$score,permutatedScores=nulldist,FDR=.05)


###################################################
### code chunk number 5: CSAR.Rnw:98-99
###################################################
sessionInfo()

`genesWithPeaks` <-
function(distances){
distances<-distances[distances$p1 >= -3000 & distances$p2<1000,]
distances$gene<-as.factor(as.character(distances$gene))
indices <- split(seq_len(nrow(distances)), distances$gene)
distances$score[distances$p1< -3000 | distances$p2>=1000]<-0
max3kb1kb=as.numeric(lapply(indices,function(x){max(c(0,distances$score[x]))}))
temp<-distances$score;temp[ distances$p1>= -2000]<-0
u3000=as.numeric(lapply(indices,function(x){max(c(0,temp[x]))}))
temp<-distances$score;temp[distances$p1< -2000 | distances$p1>= -1000]<-0
u2000=as.numeric(lapply(indices,function(x){max(c(0,temp[x]))}))
temp<-distances$score;temp[distances$p1< -1000 | distances$p1>= 0]<-0
u1000=as.numeric(lapply(indices,function(x){max(c(0,temp[x]))}))
temp<-distances$score;temp[distances$p1< 0 | distances$p2>= 0]<-0
d0=as.numeric(lapply(indices,function(x){max(c(0,temp[x]))}))
temp<-distances$score;temp[distances$p2< 0 ]<-0
d1000=as.numeric(lapply(indices,function(x){max(c(0,temp[x]))}))
fin=data.frame(name=as.character(labels(indices)),max3kb1kb,u3000,u2000,u1000,d0,d1000)
return(fin)
}

`score2wig` <-
function(experiment,file,t=2,times=1e6,description="",name=""){
if(!is.character(file)){stop("A name for the wig file is needed")}
dig<-(10^experiment$digits);
if(length(dig)==0){dig<-1}
write(paste("track type=wiggle_0 autoScale=on name=\"",name,"\" description=\"",description,"\"",sep=""),file=file,1,append=FALSE);
for (i in 1:length(experiment$chr)){
write(paste(sep='',"variableStep  chrom=",experiment$chr[i],"  span=",1),file=file,1,append=TRUE,sep="\t");
con<-file(description=experiment$filenames[i],"rb")
type<-readBin(con=con,what="character")
version<-readBin(con=con,what="character") ###Check how to put version here
considerStrand<-readBin(con=con,what="character")
w<-readBin(con=con,what="integer")
uniquelyMapped<-readBin(con=con,what="logical")
uniquePosition<-readBin(con=con,what="logical")
chr<-readBin(con=con,what="character")
chrL<-readBin(con=con,what="integer")
j=1L;times<-as.integer(times)
while(j<=chrL ){
score<-readBin(con=con,n=times,what="integer")
pos<-j+(1:length(score))
whichones<-(score>=as.integer(t*dig))
score<-score[whichones]
pos<-pos[whichones]
j<-j+times;
write.table(data.frame(pos,score/dig),file=file,append=TRUE,sep="\t",col.names=FALSE,row.names=FALSE);
}
close(con)
message(paste(experiment$chr[i],"done..."))
}

}

`mappedReads2Nhits` <-
function(input,file,chr=c("chr1","chr2","chr3","chr4","chr5"),chrL="TAIR9",w=300L,considerStrand="Minimum",uniquelyMapped=TRUE,uniquePosition=FALSE){
if(length(file)==0){stop("Parameter file has not value")}
if(!is.na(w)){w<-as.integer(w)}else{stop("ERROR: parameter w has an incorrect value")}
if(!is.element(considerStrand,c("Minimum","Sum","Foward","Reverse"))){stop("ERROR: parameter considerStrand has an incorrect value")}
##The table format should have, at least, the headers: Nhits	lengthRead	strand	chr	pos, or being a AlignedRead class object
##If file is a AlignedRead class
if(class(input)=="AlignedRead"){
##No Nhits column
if(uniquelyMapped){stop("ERROR: CSAR is not able to obtain information for each read regarding the number of hits on the genome. If you want to use all the reads, please set uniquelyMapped parameter to FALSE")}
input<-data.frame(lengthRead=as.integer(width(input)),strand=strand(input),chr=chromosome(input),pos=as.integer(position(input)))
}
else {if(uniquelyMapped & length(input$Nhits)==0){stop("ERROR: No information regarding number of hits of each read is provided. If you want to use all the reads, please set uniquelyMapped parameter to FALSE")}}

if(length(intersect(c("lengthRead","strand","chr","pos"),names(input)))<4){
stop("ERROR: input data has not all necessary columns: Nhits	lengthRead	strand	chr	pos")
}
###Other TAIRs...
if(length(chrL)==1 & is.character(chrL)){
if(chrL=="TAIR8"){chrL=c(30432563,19705359,23470805,18585042,26992728)}else{
if(chrL=="TAIR9"){chrL=c(30427671,19698289,23459830,18585056,26975502)}}
 }
if(length(chrL)!=length(chr)){
stop("ERROR: Chromosome names vector (chr) is of different length than chromosome length vector (chrL)")
}
if(length(chr[is.element(chr,unique(input$chr))])==0){
stop("ERROR: No overlap between chromosome names in mapped reads dataset and chr parameter")
}
##Correct for SOAP (and other aligmenrs) way of mapping.  
indices <- (input$strand=="-")
#input$pos[indices]<-input$pos[indices]-w+input$lengthRead[indices]
rm(indices);

#inf<-getInfoSoap(input)
if(uniquelyMapped ){input<-input[input$Nhits==1L,]};

if(uniquePosition){input<-input[!duplicated(paste(input$pos,input$chr)),]};

indices <- split(seq_len(nrow(input)), input$chr)
c1<-vector("integer",length(chr))
c2<-c1;c1_0<-c2;c2_0<-c1;chrL_0<-c1;
filenames<-vector("character",length(chr))
for(i in 1:length(chr)){
file1<-file(description=paste(chr[i],"_",file,".CSARNhits",sep=""),"wb")
temp <- mappedReads2Nhits_chr(input =  input$pos[indices[[chr[i]]]],
            strand = input$strand[indices[[chr[i]]]], chrL = chrL[i],
            w = w, considerStrand = considerStrand);
            gc(verbose=FALSE)
		writeBin("CSARNhits",con=file1)
		writeBin("v.1",con=file1) ###Check how to put version here
		writeBin(considerStrand,con=file1)
		writeBin(w,con=file1)
		writeBin(uniquelyMapped,con=file1)
		writeBin(uniquePosition,con=file1)
		writeBin(as.character(chr[i]),con=file1)
		writeBin(length(temp),con=file1)
		writeBin(temp,con=file1)
		close(file1)
		temp<-temp[temp>0L];gc(verbose=FALSE);
		c1[i]<-sum(temp);c2[i]<-sum(temp^2);chrL_0[i]<-length(temp)
		filenames[i]<-paste(chr[i],"_",file,".CSARNhits",sep="")   ####Put all path??
		message(paste("mappedReads2Nhits has just finished  ",
            chr[i], "..."));
}
info<-list(chr=chr,chrL=chrL,chrL_0=chrL_0,filenames=filenames,c1=c1,c2=c2)
rm(temp);gc(verbose=FALSE)
return(info)
}

`getThreshold` <-
function(winscores,permutatedScores,FDR){
if(length(permutatedScores)<200000){warning("The number of permutated scores is low.")}
thresholds=sort(unique(c(winscores,permutatedScores)))
eI<-numeric(length(thresholds));
Nsig<-numeric(length(thresholds));
LperScore<-length(permutatedScores)
Lwinscore<-length(winscores)
temp<-table(permutatedScores)
permutatedScores<-data.frame(score=as.numeric(names(temp)),frq=as.numeric(temp))
temp<-table(winscores)
winscores<-data.frame(score=as.numeric(names(temp)),frq=as.numeric(temp))
for(i in 1:length(thresholds)){
eI[i]=sum(permutatedScores$frq[permutatedScores$score>thresholds[i]])/LperScore
Nsig[i]=sum(winscores$frq[winscores$score>thresholds[i]])/Lwinscore

}
res<-data.frame(threshold=thresholds,Error_type_I=eI,FDR=eI/Nsig)
res$FDR[is.na(res$FDR)]<-0
tt=min(res[res$FDR<=FDR,1])
return(res[res[,1]==tt,])
}

`score_chr` <-
function(sa,con,backg=-1,test="Ratio"){
sa.nnucs<-sum(sa)
con.nnucs<-sum(con)
if(test=="Poisson"){
con<-con*as.integer(round(sa.nnucs/con.nnucs))
con[con<backg]<-backg
gc(verbose=FALSE)
con<-as.integer( round(-(ppois(sa,con,lower.tail=FALSE,log.p=TRUE))))}
if(test=="Ratio"){con[con<backg]<-backg;con<-as.integer(round(sa/con))}
rm(sa);gc(verbose=FALSE)
return(con)
}

`loadMappedReads` <-
function(file,format="SOAP",header=FALSE){
skip<-0;if(header){skip<-1}
minimum<-c("Nhits","lengthRead","strand","chr","pos")
###Different formats: SOAP, user defined...
if(length(format)==1){
if(format=="SOAP"){format<-c("name", "sequence","error","Nhits","other","lengthRead","strand","chr","pos")}}
if(length(format[is.element(format,minimum)])<length(minimum)){
stop(paste("Format should contain at least the column names:",paste(minimum,collapse="")))}
what<-vector("list",length(format))
what[is.element(format,minimum)]<-"integer"
what[(format=="strand" | format=="chr")]<-"factor"
output<-scan(file=file,what=what,flush=TRUE,comment.char="",skip=skip,quote="")
names(output)<-format
output<-data.frame(Nhits=as.integer(output$Nhits),lengthRead=as.integer(output$lengthRead),strand=output$strand,chr=output$chr,pos=as.integer(output$pos))
gc(verbose=FALSE)
return(output)
}

`sigWin_chr` <-
function(count,t,g){
pos=(1:length(count))[(count>t)];
;gc(verbose=FALSE)
start<-pos[c(TRUE,(pos[-1]-pos[-length(pos)])>g)]
end<-pos[c((pos[-length(pos)]-pos[-1])< -g,TRUE)]
gc(verbose=FALSE)
maxpos<-rep(0,length(start))
maxscore<-rep(0,length(start))
for(i in 1:length(start)){###################CHECK
temppos<-start[i]:end[i]
tempcount<-count[temppos]
maxscore[i]<-max(tempcount)
maxpos[i]<-temppos[tempcount==maxscore[i]][1]
}
rm(count);gc(verbose=FALSE)
return(list(start=start,end=end,posPeak=maxpos,score=maxscore))
}

`getPermutatedWinScores` <-
function(file,nn){
nulldis<-vector("list",length=length(nn))
for (i in 1:length(nn)){
nulldis[[i]]<-scan(file=paste(file,"-",nn[i],".permutatedWin",sep=""))
}
return(as.numeric(unlist(nulldis)))
}

`ChIPseqScore` <-
function(control,sample,backg= -1,file=NA,norm=3*10^9,test="Ratio",times=1e6,digits=2){
# norm= -1 means no normalize by number of reads
##comment errors
if(length(intersect(as.character(control$filenames),as.character(sample$filenames)))>0){stop("Some files assigned to control and sample have the same name")}
if(length(setdiff(sample$chr,control$chr))!=0){stop(paste(sample,"and",control,"have different chromosome names"))}
normcontrol=1;normsample=1;
if(norm!= -1 & !is.na(norm)){
normcontrol=norm/sum(as.numeric(control$c1))
normsample=norm/sum(as.numeric(sample$c1))
}
if(normcontrol<1){warning("The value of parameter \"norm\" is lower than w * number of mapped reads for the control.\nThis may decrease the range for the test score values, and cause problems calculating the FDR thresholds with permutations.\nPlease, consider to increase the value of the parameter \"norm\"")}
nc<-sum(as.numeric(control$chrL));ns=sum(as.numeric(sample$chrL))
ms<-sum(as.numeric(sample$c1))/ns*normsample
mc<-sum(as.numeric(control$c1))/nc*normcontrol
vc<-sum(as.numeric(control$c2))/(nc)*as.numeric(normcontrol)^2-mc^2
vs<-sum(as.numeric(sample$c2))/(ns)*as.numeric(normsample)^2-ms^2
##Background modified
#if(backg== -1){backg<-((sum(as.numeric(sample$c1))/sum(as.numeric(sample$chrL_0))*normsample-ms)*(vc/vs)^.5)+mc}
#else{backg<-((backg*normsample-ms)*(vc/vs)^.5)+mc}
backg<-as.integer(round(max(1,backg)))
filenames<-control$filenames
for (i in 1:length(sample$chr)){
file1<-file(description=paste(sample$chr[i],"_",file,".CSARScore",sep=""),"wb")
filenames[i]<-paste(sample$chr[i],"_",file,".CSARScore",sep="")
con1<-file(description=control$filenames[i],"rb");
type=readBin(con=con1,what="character"); version=readBin(con=con1,what="character"); considerStrand=readBin(con=con1,what="character"); w=readBin(con=con1,what="integer"); uniquelyMapped=readBin(con=con1,what="logical"); uniquePosition=readBin(con=con1,what="logical"); chr=readBin(con=con1,what="character");chrL=readBin(con=con1,what="integer")
con2<-file(description=sample$filenames[i],"rb");
type=readBin(con=con2,what="character"); version=readBin(con=con2,what="character"); considerStrand=readBin(con=con2,what="character"); w=readBin(con=con2,what="integer"); uniquelyMapped=readBin(con=con2,what="logical"); uniquePosition=readBin(con=con2,what="logical"); chr=readBin(con=con2,what="character");chrL=readBin(con=con2,what="integer")
writeBin("CSARScore",con=file1); writeBin(version,con=file1); writeBin(considerStrand,con=file1); writeBin(w,con=file1); writeBin(uniquelyMapped,con=file1); writeBin(uniquePosition,con=file1);writeBin(as.character(chr),con=file1); writeBin(chrL,con=file1)
j=1L;times<-as.integer(times)
while(j<=chrL ){
score1=readBin(con=con1,n=times,what="integer")
score2=readBin(con=con2,n=times,what="integer")
score1<-as.numeric(score1*normcontrol)
score2<-as.numeric(((score2*normsample-ms)*(vc/vs)^.5)+mc)
score1[score1<backg]<-backg
if(test=="Poisson"){score2<-as.integer(round((-ppois(score2,score1,lower.tail=FALSE,log.p=TRUE))*10^digits))}
if(test=="Ratio"){score2<-as.integer(round((score2/score1)*10^digits))}
writeBin(score2,con=file1)

j<-j+times;
}
close(con1)
close(con2)
close(file1)
gc(verbose=FALSE)
message(paste(sample$chr[i]," done..."))
}
info<-list(chr=sample$chr,chrL=sample$chrL,filenames=filenames,digits=digits)
rm(score1,score2);gc(verbose=FALSE)
return(info)
}

`mappedReads2Nhits_chr` <-
function(input,strand,chrL,w,considerStrand){
if(considerStrand=="Sum"){pos<-(pos2Nhits(input=input,w=w,l=chrL))};
if(considerStrand=="Foward"){pos<-(pos2Nhits(input=input[strand=="+"],w=w,l=chrL))};
if(considerStrand=="Reverse"){pos<-(pos2Nhits(input=input[strand=="-"],w=w,l=chrL))};
if(considerStrand=="Minimum"){
whichones<-(strand=="-");rm(strand);
t1<-pos2Nhits(input=input[whichones],w=w,l=chrL);
input<-input[!whichones];rm(whichones);gc(verbose=FALSE);
t2<-pos2Nhits(input=input,w=w,l=chrL);gc(verbose=FALSE);
pos<-pmin.int(t1,t2)
}
return(pos)
}

`sigWin` <-
function(experiment,t=1,g=100){
if(length(experiment$digits)==0){experiment$digits<-2}
dig<-10^experiment$digits
t<-as.integer(t*dig);g<-as.integer(round(g));
fin<-GRanges()
for (i in 1:length(experiment$chr)){
x<-as.integer(LoadBinCSAR(experiment$filenames[i]))
if(max(x)>t){
res<-sigWin_chr(count=x,t=t,g=g)
res<-GRanges(seqnames=Rle(as.character(experiment$chr[i]),length(res$score)),
ranges= IRanges(start=res$start,end=res$end), posPeak=res$posPeak,score=res$score)
seqlengths(res)<-experiment$chrL[i]
fin<-c(fin,res)}
message(paste(experiment$chr[i],"done..."))
}
rm(x);gc(verbose=FALSE)
if(length(values(fin)$score)>0){values(fin)$score<-values(fin)$score/dig;return(fin)}else{message("No read-enriched region detected")}
}

LoadBinCSAR<-function(file){
con<-file(description=file,"rb")
type=readBin(con=con,what="character")
version=readBin(con=con,what="character") ###Check how to put version here
considerStrand=readBin(con=con,what="character")
w=readBin(con=con,what="integer")
uniquelyMapped=readBin(con=con,what="logical")
uniquePosition=readBin(con=con,what="logical")
chr=readBin(con=con,what="character")
chrL=readBin(con=con,what="integer")
score=readBin(con=con,n=chrL,what="integer")
close(con)
return(score)
}

`distance2Genes` <-
function(win,gff,t= 1,d1=-3000,d2=1000){
win<-win[values(win)$score>t,]

## I can not know the final length of res, it will depends about how close the peaks and genes are.
peakName<-c();p1<-c();p2<-c();score<-c();gene<-c();le<-c();

for (chr in unique(as.character(seqnames(win)))){
message(paste("Starting",chr,"..."))
tempwin<-win[as.character(seqnames(win))==chr,]
tempgff<-gff[as.character(gff$V1)==chr,]
tempgff$V9<-as.character(tempgff$V9)
for (i in 1:length(tempwin)){
pos=values(tempwin)$posPeak[i]
name<-paste(chr,pos,sep="_")
tempPos1<-pos-tempgff$V4
tempPos2<-pos-tempgff$V5
whichPos<-(tempgff$V7=="-")
temp<-tempPos1[whichPos]
tempPos1[whichPos]<-tempPos2[whichPos]* -1
tempPos2[whichPos]<-temp*-1
whichPos=(tempPos1>=d1 & tempPos2<=d2)
temp<-tempgff[whichPos,]
peakName<-c(peakName,rep(name,length(temp$V9)))
p1<-c(p1,tempPos1[whichPos])
p2<-c(p2,tempPos2[whichPos])
score<-c(score,rep(values(tempwin)$score[i],length(temp$V9)))
gene<-c(gene,temp$V9)
le<-c(le,abs(temp$V4-temp$V5))
}
}
return(data.frame(peakName,p1,p2,score,gene,le))
}

`pos2Nhits` <-
function(input,w=300L,l){
input<-input[input>=1L & input+w<=l]
lq=length(input)
Nhits<-rep.int(0L,l)
Nhits<-.C("pos2Nhits", pos =as.integer(input),lpos=as.integer(lq), Nhits=as.integer(Nhits),w=as.integer(w),l=as.integer(l), PACKAGE="CSAR" )$Nhits
rm(input,lq);gc(verbose=FALSE)
return(Nhits)
}

`permutatedWinScores` <-
function(nn=1,control,sample,fileOutput,chr=c("chr1","chr2","chr3","chr4","chr5"),chrL="TAIR9",w=300L,considerStrand="Minimum",uniquelyMapped=TRUE,uniquePosition=FALSE,norm=3*10^9,backg=-1,t=1,g=100,times=1e6,digits=2,test="Ratio"){ 
if(uniquelyMapped){sample<-sample[sample$Nhits==1L,];control<-control[control$Nhits==1L,];};
if(uniquePosition){sample<-sample[!duplicated(paste(sample$pos,sample$strand)),];control<-control[!duplicated(paste(control$pos,control$strand)),]};
whichsample<-sample(c(rep(TRUE,length(sample[,1])),rep(FALSE,length(control[,1]))))
whichcontrol<-whichsample[(1:length(control[,1]))+length(sample[,1])]
whichsample<-whichsample[1:length(sample[,1])]

NhitsC<-mappedReads2Nhits(rbind(sample[!whichsample,],control[!whichcontrol,]),file=paste(fileOutput,"-PermutatedSet",nn,"-Control",sep=""),chr=chr,chrL=chrL,w=w,considerStrand=considerStrand,uniquelyMapped=uniquelyMapped,uniquePosition=uniquePosition)
NhitsS<-mappedReads2Nhits(rbind(sample[whichsample,],control[whichcontrol,]),file=paste(fileOutput,"-PermutatedSet",nn,"-Sample",sep=""),chr=chr,chrL=chrL,w=w,considerStrand=considerStrand,uniquelyMapped=uniquelyMapped,uniquePosition=uniquePosition)
rm(sample,control,whichsample,whichcontrol);gc(verbose=FALSE)
test<-ChIPseqScore(control=NhitsC,sample=NhitsS,backg=backg,file=paste(fileOutput,"-PermutatedSet",nn,sep=""),norm=norm,test=test,times=times,digits=digits)
unlink(NhitsC$filenames);unlink(NhitsS$filenames);
win<-sigWin(experiment=test,t=t,g=g)
file=paste(fileOutput,"-",nn,".permutatedWin",sep="")
cat(values(win)$score,file=file)
unlink(test$filenames)
message(paste("Win file for permutation",nn,"can be found at",file))
}

%\VignetteIndexEntry{CSAR Vignette}
%\VignetteDepends{CSAR}
%\VignetteKeywords{ChIPseq,Transcription,Genetics}
%\VignettePackage{CSAR}
\documentclass{article}
\usepackage[utf8x]{inputenc} 

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rcode}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textsf{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\CSAR}{\Rpackage{CSAR }}

\usepackage{graphicx}

\begin{document}
\title{An Introduction to the CSAR Package}

\author{Jose M Muino\footnote{jose.muino@wur.nl}}
\maketitle
\begin{center}
Applied Bioinformatics\\Plant Research International, Wageningen UR\\Wageningen, The Netherlands
\end{center}

<<setup, echo=FALSE, results=hide>>=
options(width=60)
options(continue=" ")
options(prompt="R> ")
@ 

\section{Introduction}
We present here a R package for the statistical detection of protein-bound genomic regions, where, considering the average DNA fragment size submitted to sequencing, single-nucleotide enrichment values are obtained. After normalization, sample and control are compared using a test based on the Poisson distribution. Test statistic thresholds to control false discovery rate are obtained through random permutation. The computational efficiency is achieved implanting the most time-consuming functions in C++ language, and integrating them in the R package. Standard outputs of the package are tables of genomic coordinates of significantly enriched region locations, level of enrichment per nucleotide position and the distance of enriched regions to annotated genomic features.
The algorithm is described in detail in \cite{Kaufmann2009}, \cite{KaufmannAccepted}, \cite{MuinoSubmitted}.

\section{Methods}

	Due to PCR artifacts a high number of reads  can represent the same sequence.  The elimination of these duplicated reads usually leads to a 15\%-25\% data reduction in a standard plant ChIP-seq experiment. This artifact is strand dependent, therefore CSAR requests that the number of extended reads that overlap a given nucleotide position should be supported by both strands independently. This is achieved by virtually  extending the mapped reads to a length of 300 bp (the average DNA fragment length submitted to the sequence process) for each strand independently, and after taken the minimum value for both strand at each nucleotide position.

Before test enrichment between sample and control, the number of overlapped reads distribution of the sample is normalize to have the same mean and variance that the control.. Subsequently,  a score enrichment is calculated based on the Poisson test or in the ratio.

Permutation is applied to calculate the FDR thresholds. The mapped reads are randomly permutated between the control and sample group, and new scores are calculated for this new permutated dataset. The procedure is repeated until have a enough number of permutated scores. This scores are used to calculate the FDR thresholds.


\section{Example}

We will use a dataset included in the \CSAR package for this demonstration. The data represent a small subset of a SEP3 ChIP-seq experiment in $Arabidopsis$ \cite{Kaufmann2009}.

First, we load the \CSAR package and the data \Rclass{CSAR-dataset}. We use the \Rclass{mappedReads2Nhits} function to calculate the number of hits (number of extended reads that overlap a particular position) per nucleotide position for the control and sample dataset. The results for each chromosome are saved in a file with the name of the chromosome and the tag used in the parameter \Rclass{file} See function \Rclass{mappedReads2Nhits} for more information about the parameter values.

<<loadData>>=
library(CSAR)
data("CSAR-dataset");
head(sampleSEP3_test)
head(controlSEP3_test)
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC$filenames
nhitsS$filenames
@

The variable nhitsC and nhitsS will have the needed information to use with the function \Rclass{ChIPseqScore} in order to calculate the read-enrichment score of the sample compared to the control for each nucleotide position. 
The results are saved in one file per each chromosome. 
\Rclass{sigWin} will generate candidate read-enriched regions, and \Rclass{score2wig} will generate a wig file that can be read by standard genome browsers.
\Rclass{distance2Genes} function will report the relative position of candidate read-enriched regions regarding the start and end position of the annotated genes.
\Rclass{genesWithPeaks} function will report genes with a candidate enriched region located near them.

<<runScore>>=
test<-ChIPseqScore(control=nhitsC,sample=nhitsS,file="test",times=10000)
test$filenames
win<-sigWin(test)
head(win)
score2wig(test,file="test.wig",times=10000)
d<-distance2Genes(win=win,gff=TAIR8_genes_test)
d
genes<-genesWithPeaks(d)
head(genes)
@ 

With each run of the function \Rclass{permutatedWinScores} one set of permutated scores is generated. Later, we can get the distribution of score values with the function \Rclass{getPermutatedWinScores}.
From this distribution, several cut-off values can be calculated to control the error of our test using functions implemented in R. In this package, it is implemented a control of the error based on FDR using the function \Rclass{getThreshold}. 

<<runPermutation>>=
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
nulldist<-getPermutatedWinScores(file="test",nn=1:2)
getThreshold(winscores=values(win)$score,permutatedScores=nulldist,FDR=.05)
@
This is a very simple function to obtain the threshold value of our test statistic controlling FDR at a desired level. Basically, for each possible threshold value, the proportion of error type I is calculated assuming that  the permutated score distribution is a optimal estimation of the score distribution under the null hypothesis, and FDR is obtained as the ratio of the proportion of error type I by the proportion of significant tests. Other functions implemented in R (eg: \Rclass{multtest} ) could be less conservative.
\bibliography{CSARVignette}{}
\bibliographystyle{plain}
 
\section{Details}

This document was written using:

<<>>=
sessionInfo()
@ 


\end{document}

\name{getPermutatedWinScores}
\alias{getPermutatedWinScores}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Obtain the read-enrichment score distribution under the null hypothesis }
\description{
 Obtain the read-enrichment score distribution under the null hypothesis 
}
\usage{
getPermutatedWinScores(file, nn)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{ Name of the file generated by permutatedWinScores }
  \item{nn}{ ID for the multiple permutation process }
  
}

\value{
Numeric vector of score values under permutation
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}

\seealso{CSAR-package, permutatedWinScores}
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate two sets of read-enrichment scores through permutation
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))

###Next function will get all permutated score values generated by permutatedWinScores function. 
##This represent the score distribution under the null hypotesis and therefore it can be use to control the error of our test.
nulldist<-getPermutatedWinScores(file="test",nn=1:2)

}

\name{sampleSEP3_test}
\alias{sampleSEP3_test}
\alias{TAIR8_genes_test}
\alias{controlSEP3_test}
\docType{data}
\title{Partial dataset of a ChIP-seq experiment}
\description{
  Partial dataset of a Solexa DNA library obtained from a ChIP-seq experiment in Arabidopsis
}

\source{
  Kaufmann et al. (2009) Target Genes of the MADS Transcription Factor SEPALLATA3: Integration of Developmental and Hormonal Pathways in the $Arabidopsis$ Flower. PLoS Biol 7:e1000090
}

\examples{
data(CSAR-dataset)

}
\keyword{datasets}

\name{distance2Genes}
\alias{distance2Genes}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate relative positions of read-enriched regions regarding gene position }
\description{
  Calculate relative positions of read-enrichment regions regarding gene position
}
\usage{
distance2Genes(win, gff, t = 1, d1 = -3000, d2 = 1000)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{win}{ GRange structure obtained with the function \code{sigWin} }
  \item{gff}{ Data.frame structure obtained after loading a desired gff file}
  \item{t}{ Integer. Only distances of read-enriched regions with a score bigger than \code{t} will be considered}
  \item{d1}{ Negative integer. Minimum relative position regarding the start of the gene to be considered}
  \item{d2}{ Positive integer. Maximum relative position regarding the end of the gene to be considered}
}

\value{
  data.frame structure where each row represents one relative position, and each column being:
  \item{peakName }{read-enriched region name}
  \item{p1 }{relative position regarding the start of the \code{gene} }
  \item{p2 }{relative position regarding the end of the \code{gene}}
  \item{gene }{name of the gene}
  \item{le }{length (bp) of the gene}
  
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr
Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ genesWithPeaks, CSAR-package }
\examples{


##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We calculate the candidate read-enriched regions
win<-sigWin(test)


##We calculate relative positions of read-enriched regions regarding gene position
d<-distance2Genes(win=win,gff=TAIR8_genes_test)

}

\name{ChIPseqScore}
\alias{ChIPseqScore}
\alias{score_chr}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate read-enrichment scores for each nucleotide position}
\description{
  Calculate read-enrichment scores for each nucleotide position
}
\usage{
ChIPseqScore(control, sample, backg = -1, file = NA, norm = 3 * 10^9,  test = "Ratio",times=1e6,digits=2)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{control}{ data.frame structure obtained by mappedReads2Nhits }
  \item{sample}{ data.frame structure obtained by mappedReads2Nhits }
  \item{backg}{ Due low coverage in the control, there could be regions with no hits. Any region with a hit value lower than \code{backg} in the \code{control} will be set to the value of \code{backg}}
  \item{file}{ Name of the file where you wan to save the results (if desired) }
  \item{norm}{ Integer value. Number of hits will be reported by number of hits per \code{norm} nucleotides }
  \item{test}{Use a score based on the poisson distribution ("Poisson") or in the ratio ("Ratio") }
  \item{times}{ To be memory efficient, CSAR will only upload to the RAM memory fragments of length \code{times}. A bigger value means more RAM memory needed but whole process will be faster}
  \item{digits}{Number of decimal digits used to report the score values}
}

\value{
  A list to be used for other functions of the CSAR package
    \item{chr }{Chromosme names}
	\item{chrL }{Chromosme length (bp)}
	\item{filenames }{Name of the files where the score values are storaged}
	\item{digits}{Score values storaged on the files need to be divided by 10^\code{digits}}
	
  }
\details{
Different sequencing efforts yield different number of sequenced reads, for this reason the "number of hits" at each nucleotide position is normalized by the total number of nucleotides sequenced.
Subsequently, the number of hits for the sample is normalize to have the same mean and variance than the control, for each chromosome independently or for the whole set of chromosomes (depending of the value of \code{normEachChrInd}).
Due low coverage, there could be regions with no hits. Any region with a hit value lower than \code{backg} in the \code{control} will be set to the value of \code{backg}
For each nucleotide position, a read-enrichment score will be calculated with the Poisson test, or with the ratio.


}
  
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistical detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package }

\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

}

\name{genesWithPeaks}
\alias{genesWithPeaks}
\title{ Provide table of genes with read-enriched regions, and their location}
\description{
  Provide table of genes with read-enriched regions, and their location
}
\usage{
genesWithPeaks(distances)
}
\arguments{
  \item{distances}{ data.frame structure obtained by \code{distances2Genes}}
}

\value{
  data.frame structure with each coloumn being:
    \item{name }{name of the gene}
  \item{max3kb1kb }{maximum score value for the region 3Kb upstream to 1Kb dowstream}
  \item{u3000 }{maximum score value for the region 3Kb upstream to 2Kb upstream}
  \item{u2000 }{maximum score value for the region 2Kb upstream to 1Kb upstream}
  \item{u1000 }{maximum score value for the region 1Kb upstream to 0Kb upstream}
  \item{d0 }{maximum score value for the region 0Kb upstream to 0Kb dowstream}
  \item{d1000 }{maximum score value for the region 0Kb dowstream to 1Kb dowstream}

}

\details{
This function report for each gene, the maximum peak score in different regions near of the gene. The input of the function is the distances between genes and peaks calculated by \code{distance2Genes}
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr 
Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ distance2Genes,CSAR-package }
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We calculate the candidate read-enriched regions
win<-sigWin(test)

##We calculate relative positions of read-enriched regions regarding gene position
d<-distance2Genes(win=win,gff=TAIR8_genes_test)

##We calculate table of genes with read-enriched regions, and their location
genes<-genesWithPeaks(d)


}

\name{mappedReads2Nhits}
\alias{mappedReads2Nhits}
\alias{mappedReads2Nhits_chr}
\alias{pos2Nhits}
\alias{pos2Nhits_old}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate number of overlapped extended reads per nucleotide position }
\description{
  Calculate number of overlapped extended reads per nucleotide position
}
\usage{
mappedReads2Nhits(input, file , chr = c("chr1", "chr2", "chr3", "chr4", "chr5"), chrL = "TAIR9", w = 300L, considerStrand = "Minimum", uniquelyMapped = TRUE, uniquePosition = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{input}{data loaded with loadMappedReads or an AlignedRead object from the ShortRead package}
  \item{file}{Name of the file where the results will be saved. If NA the results will not be saved in a file. }
  \item{chr}{Character vector containing the chromosome names as identified on \code{input}. }
  \item{chrL}{Numeric vector containing the length (bp) of the chromosomes. It should be in the same order than \code{chr}}
  \item{w}{Integer corresponding to the desired length of the extended reads. An advised value will be the average fragment length of the DNA submitted to sequence (usually 300 bp).}
  \item{considerStrand}{Character value.
  
  "Minimum"=>Default value. Report the minimum number of hits at each nucleotide position for both strands.
  
  "Foward"=> Report the number of hits at each nucleotide position for the "foward" strands (the one denoted as "+" in \code{q}).
  
  "Reverse"=>Report the number of hits at each nucleotide position for the "reverse" strands (the one denoted as "-" in \code{q}). 
  
  "Sum"=>Report the sum of number of hits at each nucleotide position for both strands.
  }
  \item{uniquelyMapped}{Logic value, If TRUE, only consider uniquely mapped reads.}
  \item{uniquePosition}{Logic value. If TRUE, only consider reads mapped in different positions.}
 
  
}

\value{
A list to be used for other functions of the CSAR package
   \item{chr }{Chromosme names}
	\item{chrL }{Chromosme length (bp)}
	\item{chrL_0 }{Number of nucleotide positions with at least one extended read}
	\item{chrL_0 }{Number of nucleotide positions with at least one extended read}
	\item{filenames }{Name of the files where the Nhits values are storaged}
	\item{c1}{Sum of all the Nhits values for each chromosome}
	\item{c2}{Sum of all the Nhits square values for each chromosome}
}

\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistical detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package }

\examples{

#For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
#We calculate the number of hits for each nucleotide posotion for the sample. We do that just for chromosome chr1, and for positions from 1 bp to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


}

\name{score2wig}
\alias{score2wig}
\alias{LoadBinCSAR}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Save the read-enrichment scores at each nucleotide position in a .wig file format }
\description{
  Save the read-enrichment scores  at each nucleotide position in a .wig file format that can be visualize by a genome browser (eg: Integrated Genome Browser)
}
\usage{
score2wig(experiment, file, t = 2, times = 1e6,description="", name="")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{experiment}{ Output of the function \code{ChIPseqScore} }
  \item{file}{ Name of the output .wig file}
  \item{t}{ Only nucleotide positions with a read-enrichment score bigger than \code{t} will be reported }
  \item{times}{ To be memory efficient, CSAR will only upload to the RAM memory fragments of length \code{times}. A bigger value means more RAM memory needed but whole process will be faster}
\item{description}{ Character. It adds a description to the wig file. The description will be shown by the genome browser used to visualize the wig file. }
\item{name}{ Character. It adds a wig to the wig file. The name will be shown by the genome browser used to visualize the wig file. }
  }

\value{
  None. Results are printed in a file
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package }
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide position for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))

##Since we will not need the raw data anymore, we could delete it from the RAM memory
rm(sampleSEP3_test,controlSEP3_test);gc(verbose=FALSE)
##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We generate a wig file of the results to visualize them in a genome browser
score2wig(test,file="test.wig")

}

\name{sigWin}
\alias{sigWin}
\alias{sigWin_chr}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Calculate regions of read-enrichment}
\description{
  Calculate regions of read-enrichment
}
\usage{
sigWin(experiment, t = 1, g = 100)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{experiment}{ Output of the function \code{ChIPseqScore}}
  \item{t}{ Numeric value. Read-enriched regions are calculated as genomic regions with score values bigger than \code{t} }
  \item{g}{ Integer value. The maximum gap allowed between regions. Regions that are less than \code{g} bps away will be merged.  }
  
}

\value{
  An object of type'GRange' with its values being:
   \item{seqnames}{Chromosome name}
  \item{ranges }{An IRanges object indicating start and end of the read-enriched region}
  \item{posPeak }{Position of the maximum score value on the read-enriched region}
  \item{score }{Maximum score value on the read-enriched region}
 
  
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr
Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package }
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We calculate the candidate read-enriched regions
win<-sigWin(test)

}

\name{getThreshold}
\alias{getThreshold}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate the threshold value corresponding to control FDR at a desired level}
\description{
  Calculate the threshold value corresponding to control FDR at a desired level
}
\usage{
getThreshold(winscores, permutatedScores, FDR)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{winscores}{ Numeric vector with score values obtained from the \code{sigWin} function }
  \item{permutatedScores}{ Numeric vector with the permutated read-enrichment score values}
  \item{FDR}{ Numeric value with the desired FDR control }
}
\value{
 A table with the columns being:
  \item{threshold}{The threshold value}
  \item{p-value}{The p-value obtained from the permutated score ditribution}
  \item{FDR}{ The FDR control obtained using \code{threshold}}
}
\details{
This is a very simple function to obtain the threshold value of our test statistic controlling FDR at a desired level. Other functions implemented in R (eg: \code{multtest}) could be more sophisticated.
Basically, for each possible threshold value, the proportion of error type I is calculated assuming that the permutated score distribution is a optimal estimation of the score distribution under the null hypothesis.
This is, the proportion of permutated scores exceding the considered threshold value is used as an estimation of the error type I of our statisitic.
FDR is obtained as the ratio of the proportion of error type I by the proportion of significant tests. 

}

\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}

\seealso{CSAR-package,getPermutatedWinScores, sigWin}
\examples{
##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We calculate the candidate read-enriched regions
win<-sigWin(test)


##We calculate two sets of read-enrichment scores through permutation
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))

###Next function will get all permutated score values generated by permutatedWinScores function. 
##This represent the score distribution under the null hypotesis and therefore it can be use to control the error of our test.
nulldist<-getPermutatedWinScores(file="test",nn=1:2)

##From this distribution, several cut-off values can be calculated to control the error of our test. 
##Several functions  in R can be used for this purpose.
##In this package we had implemented a simple method for the control of the error based on FDR"
getThreshold(winscores=values(win)$score,permutatedScores=nulldist,FDR=.01)
}

\name{permutatedWinScores}
\alias{permutatedWinScores}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Calculate scores for permutated read-enriched regions}
\description{
Calculate scores for permutated read-enriched regions
}
\usage{
permutatedWinScores(nn = 1, control, sample, fileOutput, chr = c("chr1", "chr2", "chr3", "chr4", "chr5"), chrL = "TAIR9", w = 300L, considerStrand = "Minimum", uniquelyMapped = TRUE, uniquePosition = FALSE, norm = 3 * 10^9, backg = -1, t = 1, g = 100,times=1e6,digits=2,test="Ratio")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nn}{ ID to identify each permutation}
  \item{control}{ data.frame structure obtained by loading the mapped reads with the function LoadMappedReads() }
  \item{sample}{ data.frame structure obtained by loading the mapped reads with the function LoadMappedReads()}
  \item{fileOutput}{ Name of the file were the results will be written }
  \item{chr}{ Character vector containing the chromosome names as identified on \code{q}.}
  \item{chrL}{ Numeric vector containing the length (bp) of the chromosomes. It should be in the same order than \code{chr} }
  \item{w}{ Integer corresponding to the desired length of the extended reads.  }
  \item{considerStrand}{Character value.
  
  "Minimum"=>Default value. Report the minimum number of hits at each nucleotide position for both strands.
  
  "Foward"=> Report the number of hits at each nucleotide position for the "foward" strands (the one denoted as "+" in \code{q}).
  
  "Reverse"=>Report the number of hits at each nucleotide position for the "reverse" strands (the one denoted as "-" in \code{q}). 
  
  "Sum"=>Report the sum of number of hits at each nucleotide position for both strands.
  }
  \item{uniquelyMapped}{  Logic value, If TRUE, only consider unquely mapped reads. }
  \item{uniquePosition}{ Logic value. If TRUE, only consider reads mapped in different positions. }
  \item{norm}{ Integer value. Number of hits will be reported by number of hits per \code{norm} nucleotides }
  \item{backg}{ Any region with a hit value lower than \code{backg} in the \code{control} will be set to the value of \code{backg} }
  \item{t}{Numeric value. Read-enriched regions are calculated as genomic regions with score values bigger than \code{t}  }
  \item{g}{ Integer value. The maximum gap allowed between regions. Regions that are less than \code{g} bps away will be merged. }
  \item{times}{ To be memory efficient, CSAR will only upload to the RAM memory fragments of length \code{times}. A bigger value means more RAM memory needed but whole process will be faster}
  \item{digits}{Number of decimal digits used to report the score values}
\item{test}{Use a score based on the poisson distribution ("Poisson") or in the ratio ("Ratio") }
}
\value{
   The file \code{filePutput} is created with its values being the permuated score values.
  
}

\details{
The parameter values should be the same than the one used in \code{sigWin}, \code{ChIPseqScore}, and \code{mappedReads2Nhits}.
  The label "control" and "sample" is asigned to each read to identify from which group they came. Labels are randomly permutated, and read-enriched regions for this new permuated dataset are calculated.
}

\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr
Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package,getPermutatedWinScores}
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate two sets of read-enrichment scores through permutation
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))

}

\name{loadMappedReads}
\alias{loadMappedReads}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Load mapped reads}
\description{
 This function load the output file of a read mapping software (eg:SOAP)
}
\usage{
loadMappedReads(file, format = "SOAP", header = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{ File name to load }
  \item{format}{ Format of the file. "SOAP" for the output of the soap software and "MAQ" for the maq software. Other user formats can be provided as a character vector for the \code{file} column names. Columns named: "Nhits", "lengthRead", "strand", "chr", and "pos"  are needed.    }
  \item{header}{ Logical value indicating if the first line of the file should be skipped (TRUE) or not (FALSE) }
}
\value{
  data.frame structure that can be used by \code{mappedReads2Nhits}
}
\references{ Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.}
\author{ Jose M Muino, \email{jose.muino@wur.nl}}
\seealso{ CSAR-package }
\examples{
##We load the mapped reads:
#sample<-loadMappedReads(file=file,format="SOAP",w=300,header=F)
##where file is the name and path of the output file of the mapping process.

}

\name{CSAR-package}
\alias{CSAR-package}
\docType{package}
\title{
Statistical tools for the analysis of ChIP-seq data
}
\description{
Statistical tools for ChIP-seq data analysis.\cr The package is oriented to plant organisms, and compatible with standard file formats in the plant research field.
}
\details{
\tabular{ll}{
Package: \tab CSAR\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2009-11-09\cr
License: \tab Artistic-2.0\cr
LazyLoad: \tab yes\cr
}

}
\author{
Jose M Muino

Maintainer: Jose M Muino <jose.muino@wur.nl>

}
\references{
Muino et al. (submitted). Plant ChIP-seq Analyzer: An R package for the statistcal detection of protein-bound genomic regions. \cr Kaufmann et al.(2009).Target genes of the MADS transcription factor SEPALLATA3: integration of developmental and hormonal pathways in the Arabidopsis flower. PLoS Biology; 7(4):e1000090.
}
\examples{

##For this example we will use the a subset of the SEP3 ChIP-seq data (Kaufmann, 2009)
data("CSAR-dataset");
##We calculate the number of hits for each nucleotide posotion for the control and sample. We do that just for chromosome chr1, and for positions 1 to 10kb
nhitsS<-mappedReads2Nhits(sampleSEP3_test,file="sampleSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))
nhitsC<-mappedReads2Nhits(controlSEP3_test,file="controlSEP3_test",chr=c("CHR1v01212004"),chrL=c(10000))


##We calculate a score for each nucleotide position
test<-ChIPseqScore(control=nhitsC,sample=nhitsS)

##We calculate the candidate read-enriched regions
win<-sigWin(test)

##We generate a wig file of the results to visualize tehm in a genome browser
score2wig(test,file="test.wig")

##We calculate relative positions of read-enriched regions regarding gene position
d<-distance2Genes(win=win,gff=TAIR8_genes_test)

##We calculate table of genes with read-enriched regions, and their location
genes<-genesWithPeaks(d)

##We calculate two sets of read-enrichment scores through permutation
permutatedWinScores(nn=1,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))
permutatedWinScores(nn=2,sample=sampleSEP3_test,control=controlSEP3_test,fileOutput="test",chr=c("CHR1v01212004"),chrL=c(100000))

###Next function will get all permutated score values generated by permutatedWinScores function. 
##This represent the score distribution under the null hypotesis and therefore it can be use to control the error of our test.
nulldist<-getPermutatedWinScores(file="test",nn=1:2)

##From this distribution, several cut-off values can be calculated to control the error of our test. 
##Several functions  in R can be used for this purpose.
##In this package we had implemented a simple method for the control of the error based on FDR"
getThreshold(winscores=values(win)$score,permutatedScores=nulldist,FDR=.01)


}
